/**
 * Copyright (C) 2005-2006 Funambol
 *
 *  This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.funambol.email.inboxlistener.engine;


import com.funambol.framework.core.Alert;
import com.funambol.framework.core.Target;
import com.funambol.framework.core.Meta;
import com.funambol.framework.core.Item;
import com.funambol.framework.core.CmdID;
import com.funambol.framework.tools.beans.BeanFactory;


/**
 *
 * @version $Id: NotificationWrapper.java,v 1.1 2006/02/15 13:21:44 gbmiglia Exp $
 */
public class NotificationWrapper
{

  /**   */
  private WSAccount wsa      = null;
  /**   */
  private MailboxAccount mba = null;
  /**   */
  private WSTools wsTools    = null;


  //--------------------------------------------------------------- CONSTRUCTORS


  /**
   *
   */
  public NotificationWrapper(MailboxAccount mba, WSAccount wsa){
       this.mba = mba;
       this.wsa = wsa;
  }

  //------------------------------------------------------------- PUBLIC METHODS

   /**
    *
    */
   public void callNotification() throws Exception {
      wsTools  = new WSTools(wsa.getWsEndPoint(),
                             wsa.getWsUsername(),
                             wsa.getWsPassword());
      sendNotificationMessages(mba.getUser());
   }


  /**
   *
   */
  public void sendNotificationMessages(String deviceId) throws Exception  {

        Alert[] alerts = createMailAlerts();
        String xml = getXMLAlerts(alerts);

        System.out.println("XML: " + xml);

        Object[] params = new Object[] {deviceId, xml, new Integer(1)};

        wsTools.invoke("sendNotificationMessages", params);
  }


  //------------------------------------------------------------ PRIVATE METHODS

  /**
   *
   * @todo insert parameters int he configuration file
   *
   */
  private Alert[] createMailAlerts() {

      Target t1 = new Target(wsa.getWsSyncSource());
      Meta meta1 = new Meta();
      meta1.setType("application/vnd.omads-email+xml");
      Item i1 = new Item(null, t1,meta1, null, false);

      Alert alert1 = new Alert(new CmdID(0), false, null, 210, new Item[]{i1});

      Alert[] alerts = new Alert[1];
      alerts[0] = alert1;

      return alerts;
  }

  /**
   *
   */
  private String getXMLAlerts(Alert[] alerts) throws Exception  {
      return BeanFactory.marshal(alerts);
  }

}
