/**
 * Copyright (C) 2005-2006 Funambol
 *
 *  This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.funambol.email.items.dao;


import java.util.logging.Logger;
import java.util.logging.Level;
import javax.mail.Message;
import javax.mail.Flags;
import javax.mail.MessagingException;
import javax.mail.Folder;
import javax.mail.FetchProfile;
import com.sun.mail.imap.IMAPFolder;

import com.funambol.email.exception.EntityException;
import com.funambol.email.util.*;


/**
 * This class implements methods to access data
 * in Mail Server datastore.
 *
 * @version $Id: EntityDAO.java,v 1.2 2006/02/06 09:01:39 gbmiglia Exp $
 */
public class EntityDAO {


    // ------------------------------------------------------------ Private data

    protected Logger  log = Logger.getLogger(Def.LOGGER_NAME);


    // -------------------------------------------------------------- Properties

    /**
     *
     */
    public EntityDAO(){
     }




    // -----------------------------------------------------------Public Methods


    /**
     *
     *
     *
     * @param sourceFolder IMAPFolder
     * @param targetFolder IMAPFolder
     * @param uid long
     * @throws EntityException
     */
    public void moveImapItem(IMAPFolder sourceFolder,
                             IMAPFolder targetFolder,
                             long uid)
      throws EntityException {

        if (log.isLoggable(Level.FINEST)) {
            log.finest("DAO start moveImapItem ");
        }

        try {

          Message msgToDelete    = sourceFolder.getMessageByUID(uid);

          Message[] msgsToDelete = new Message[1];
          msgsToDelete[0]        = msgToDelete;

  		  targetFolder.appendMessages(msgsToDelete);

	      sourceFolder.setFlags(msgsToDelete, new Flags(Flags.Flag.DELETED), true);

        }catch (MessagingException e){
            throw new EntityException(e);
        }

    }

  //------------------------------------------------------------ PRIVATE METHODS



}
