/**
 * Copyright (C) 2005-2006 Funambol
 *
 *  This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.funambol.email.items.model;

import com.funambol.email.util.Def;

/**
 *
 * @version $Id: ClientMessage.java,v 1.2 2006/02/06 09:02:33 gbmiglia Exp $
 */
public class ClientMessage {

    /**   id  */
    private String  uid = null ; // folder_id + separator + uid

    /**   header message-id  */
    private String  message_id = null ;

    /**   message  */
    private String  streamMessage = null ;

    /**  origination date   */
    private String created = null;
    /**  received date   */
    private String received = null;
    /**  modified date   */
    private String modified = null;

    /** read  (boolean)*/
    private String read = null;
    /** forwarded  (boolean)*/
    private String forwarded = null;
    /** replied  (boolean)*/
    private String replied = null;
    /** deleted  (boolean)*/
    private String deleted = null;
    /** flagged  (boolean)*/
    private String flagged = null;


    /**
     * the uid contains:
     * -  FID : folder id
     * -  SEPARATOR : "/" default
     * -  FMID : message id considering folder
     *
     *
     * @param UID String
     * @param message_id String
     * @param streamMessage String
     * @param created String
     * @param received String
     * @param modified String
     * @param read String
     * @param forwarded String
     * @param replied String
     * @param deleted String
     * @param flagged String
     */
    public ClientMessage(String UID,
                         String message_id,
                         String streamMessage,
                         String created,
                         String received,
                         String modified,
                         String read,
                         String forwarded,
                         String replied,
                         String deleted,
                         String flagged) {

        this.uid           = UID ;
        this.message_id    = message_id ;
        this.streamMessage = streamMessage;

        this.created       = created;
        this.received      = received;
        this.modified      = modified;

        this.read          = read;
        this.forwarded     = forwarded;
        this.replied       = replied;
        this.deleted       = deleted;
        this.flagged       = flagged;
    }

    /**
     * Returns the id of this Message
     * @return the id of this Message
     */
    public String getUID() {
        return this.uid;
    }

    /**
     * Returns the message-id of this Message
     * @return the message-id of this Message
     */
    public String getMessage_id() {
        return this.message_id;
    }

    /**
     * Returns the message of this Message
     * @return the message of this Message
     */
    public String getStreamMessage() {
        return this.streamMessage;
    }

    //--------------------------------------------------------------------- DATE

    /**
     * Returns the origination date of this Message
     * @return the origination date of this Message
     */
    public String getCreated() {
        return this.created;
    }

    /**
     * Returns the received date of this Message
     * @return the received date of this Message
     */
    public String getReceived() {
        return this.received;
    }

    /**
     * Returns the modified date of this Message
     * @return the modified date of this Message
     */
    public String getModified() {
        return this.modified;
    }

    //------------------------------------------------------------------ BOOLEAN

    /**
     * Returns if the Message has been read
     * @return true if Message has been read
     */
    public String getRead() {
        return this.read;
    }

    /**
     * Returns if the Message has been forwarded
     * @return true if Message has been forwarded
     */
    public String getForwarded() {
        return this.forwarded;
    }

    /**
     * Returns if the Message has been replied
     * @return true if Message has been replied
     */
    public String getReplied() {
        return this.replied;
    }

    /**
     * Returns if the Message has been deleted
     * @return true if Message has been deleted
     */
    public String getDeleted() {
        return this.deleted;
    }

    /**
     * Returns if the Message has been flagged
     * @return true if Message has been flagged
     */
    public String getFlagged() {
        return this.flagged;
    }

}
