/**
 * Copyright (C) 2005-2006 Funambol
 *
 *  This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.funambol.email.items.model;

import javax.mail.Message;

import com.funambol.email.util.Def;

/**
 *
 * @version $Id: EISMessage.java,v 1.2 2006/02/06 09:02:33 gbmiglia Exp $
 */
public class EISMessage {

    /**
     * GUID :  folder_id + separator + uid
     */
    private String  guid       = null ;

    /**
     * header message-id
     */
    private String  message_id = null ;


    /**
     * javaMail Message
     */
    private Message  message   = null ;


    /**
     * the uid contains:
     * -  FID  : folder id
     * -  FMID : message id considering folder
     *
     * @param FID String
     * @param FMID String
     * @param message_id String Messagge-ID in the header
     * @param message Message
     */
    public EISMessage(String FID,
                      String FMID,
                      String message_id,
                      Message message) {
        this.guid       = FID + Def.SEPARATOR + FMID ;
        this.message_id = message_id;
        this.message    = message;
    }

    /**
     * Returns the id of this Message
     * @return the id of this Message
     */
    public String getGUID() {
        return this.guid;
    }

    /**
     * Returns the Message-ID of this Message
     * @return the Message-ID of this Message
     */
    public String getMesssage_id() {
        return this.message_id;
    }

    /**
     * Returns the message of this Message
     * @return the message of this Message
     */
    public Message getMessage() {
        return this.message;
    }


}
