/**
 * Copyright (C) 2005-2006 Funambol
 *
 *  This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.funambol.email.transport;

import java.util.Locale;
import java.util.Locale;
import javax.mail.Session;
import javax.mail.Store;

import com.funambol.email.exception.EmailAccessException;


/**
 *
 * <p>Interface for Mail Server Wrapper </p>
 *
 * @version $Id: IMailServerWrapper.java,v 1.2 2006/02/06 09:03:37 gbmiglia Exp $
 */
public interface IMailServerWrapper {


    /**
     * opens the connection with the mail server
     *
     * @param outgoingServer String
     * @param incomingServer String
     * @param incomingPort String
     * @param language String
     * @param user String
     * @param password String
     * @param isSSL boolean
     * @throws EmailAccessException
     */
    public void openConnection(String  outgoingServer,
                               String  incomingServer,
                               String  incomingPort,
                               String  language,
                               String  user,
                               String  password,
                               boolean isSSL)
      throws EmailAccessException ;


    /**
     * closes the connection with the mail server
     *
     * @throws EmailAccessException
     */
    public void releaseConnection() throws EmailAccessException ;


    /**
     *
     *
     * @param outgoingServer String
     * @param incomingServer String
     * @param incomingPort String
     * @param user String
     * @param password String
     * @param isSSL boolean
     * @throws EmailAccessException
     */
    public void checkUser(String  outgoingServer,
                           String  incomingServer,
                           String  incomingPort,
                           String  user,
                           String  password,
                           boolean isSSL)
     throws EmailAccessException;


    /**
     *
     *
     * @return Session
     */
    public Session getSession();

    /**
     *
     * @return Store
     */
    public Store getStore();


    /**
     *
     *
     * @return Locale
     */
    public Locale getLocale();

}
